unit Main;

{
   :   
   :    Winamp-
    :  
           pvabox@mail.ru
}


{ ------------------------------------------------------------------------- }
{        JvHidControllerClass,             }
{      JEDI,   :                  }
{  http://sourceforge.net/projects/jvcl/files/                              }
{                                                                           }
{         RegData.pas:               }
{                                                                           }
{        Type TRegData = record..;                                          }
{        procedure WriteRegData(Reg: TRegData);                             }
{        function  ReadRegData: TRegData;                                   }
{ ------------------------------------------------------------------------- }


interface

uses
  Windows, Messages, Dialogs, Classes, Graphics, Controls, SysUtils,
  Forms, StdCtrls, ExtCtrls, ComCtrls, ShellApi, RegData,
  JvHidControllerClass, JvComponentBase;

const
  MaxValue = 512;                     {   , max 575}
  FIntMin  = 4;                       {  }

  ModulName = 'BCM Dynamic plugin';   {  }
  TitleDeviceOn  = ModulName+'   :    device connected';
  TitleDeviceOff = ModulName+'   : no device connected';

//  HID 
  ProductName  = 'BCM Dynamic USB Device'; { USB }
  VendorID     =  $16c0;                   {VID}
  ProductID    =  $05df;                   {PID}

type
  TFFTData    = array[0..MaxValue] of Byte;
  TFFTTemp    = array[0..MaxValue] of Single;
  TRef        = array[0..7] of Single;
  TBus        = array[0..7] of Byte;
  TBin        = array[0..7] of Boolean;

  TForm1      = class(TForm)
    Label1         : TLabel;
    Label2         : TLabel;
    Label3         : TLabel;
    Label4         : TLabel;
    Label5         : TLabel;
    Label6         : TLabel;
    Label7         : TLabel;
    PanelFFT       : TPanel;
    PanelLamp      : TPanel;
    ImageFFT       : TImage;
    ImageLamp      : TImage;
    CheckBoxStrob  : TCheckBox;
    CheckBoxSoft: TCheckBox;
    CheckBoxBorder : TCheckBox;
    CheckBoxSave   : TCheckBox;
    ComboBoxMode   : TComboBox;
    ComboBoxFilter : TComboBox;
    GroupBoxEffect : TGroupBox;
    GroupBoxMode   : TGroupBox;
    GroupBoxSet    : TGroupBox;
    GroupBoxSave   : TGroupBox;
    ScrollBarFrom  : TScrollBar;
    ScrollBarTo    : TScrollBar;
    Render         : TTimer;
    HidCtl         : TJvHidDeviceController;

    procedure Ic(n: Integer;Icon: TIcon);
    procedure onMinimizeProc(Sender: TObject);
    procedure ScrollBarFromChange(Sender: TObject);
    procedure ScrollBarToChange(Sender: TObject);
    procedure ComboBoxFilterChange(Sender: TObject);
    procedure HidCtlArrival(HidDev: TJvHidDevice);
    function  HidCtlEnumerate(HidDev: TJvHidDevice;
                              const Idx: Integer): Boolean;
    procedure HidCtlRemoval(HidDev: TJvHidDevice);
    function  WorkDevSetFeature(Bus: TBus): Boolean;
    procedure TimerRender(Sender: TObject);


    private
      { Private declarations }
    public
      { Public declarations }
      WorkDev   : TJvHidDevice;{  HID }
    protected
      procedure ControlWindow(var Msg: TMessage); message WM_SYSCOMMAND;
      procedure IconOnClick  (var Msg: TMessage); message WM_USER+1;
  end;

var
  //   ,     
  Form1   : TForm1;         {  }
  FFTData : TFFTData;       {   VisWinamp}
  BufLine : TFFTTemp;       {  Line}
  BufPeak : TFFTTemp;       {  Peak}
  BufFlash: TBus;           {  Flash}
  Ref     : TRef;           {  }
  BufStrob: TBin;           {  Strob}
  bLamp   : TBitMap;        {  }
  BufFFT  : TBitMap;        {  ImageFFT}
  FilNamb : Byte = 0;       {  1..8; 0 -   }
  Rg      : TRegData;       {    - RegData.pas}


//=========== ,    VisWinamp ===========//

  procedure ModuleInit;
  procedure ModuleQuit;

//=================================================================//

implementation

{$R *.dfm}   {    }


 //====================    ===================//

function FFTFilter: TBus;
//     . 
//        .
const
  Zoom    : Single = 3;   {   >=1}
  Freeze  : Single = 2;   {     >=1}
  PeakFall: Single = 1;   {    >=1}

var
  n,f,dx:      Word;
  max,k,sa,sb: Single;

begin
  for n:= 0 to MaxValue do
  begin
    //    zoom   
    dx:= Round(Zoom*FFTData[n]);
    if dx > 255 then FFTData[n]:= 255
                else FFTData[n]:= dx;

    //      
    if FFTData[n] <> BufLine[n] then           {   }
      BufLine[n]:= BufLine[n]+(FFTData[n]-BufLine[n])/Freeze;

    //   
    if BufLine[n] >= BufPeak[n]
       then BufPeak[n]:= BufLine[n]            {}
       else BufPeak[n]:= BufPeak[n]-PeakFall;  {}
    if BufPeak[n] < 0 then BufPeak[n]:= 0;     {   }

    //   Winamp     
    FFTData[n]:= 0;
  end;

    //  .    
    //       .
    //     .
    for f:= 1 to 8 do                    { 8 }
      begin
        max:= 0;
        n:= (Rg.Fb[f]-Rg.Fa[f]) Div 2;   {-    }
        for dx:= 1 to n do               {    }
          begin
            k:= dx/n;                    { -   }
            sa:= k*BufLine[Rg.Fa[f]+dx]; {     }
            sb:= k*BufLine[Rg.Fb[f]-dx]; {     }
            if sa > max then max:= sa;   {   }
            if sb > max then max:= sb;   {   }
          end;
        Result[f-1]:= Round(max);        {  }
      end;
end;


function BinToByt(Bin: TBin): Byte;
//     
var
  n: Byte;
begin
  Result:=0;
  for n:= 0 to 7 do
    if Bin[n] then Result:= Result + (1 shl n);
end; 


function Illumination(Bus: TBus): TBus;
//    

const
  Dynamic  : Single = 0.15;  {0  <   <= 1}
  FlashFall: Single = 64;    {   51..85}

var
    tmp,Bin: TBin;
    Col,n,S: Byte;

begin

  //    //
  //       
  Col:= 0;         {-   ->   0..7}
  for n:= 0 to 7 do
    begin
      Ref[n]:= Ref[n]+(Bus[n]-Ref[n])*Dynamic;   { }
      tmp[n]:= Bus[n] > Ref[n];                  { }
      if tmp[n] then Col:= Col+1;                {  }
    end;


  //     //
  //     
  Case Form1.ComboBoxMode.ItemIndex of

    // 
    0: Bin:= tmp;                                {  }

    //   - 4 
    1: begin                                     { }
         Bin[0]:= tmp[6];   Bin[4]:= tmp[0];
         Bin[1]:= tmp[4];   Bin[5]:= tmp[2];
         Bin[2]:= tmp[2];   Bin[6]:= tmp[4];
         Bin[3]:= tmp[0];   Bin[7]:= tmp[6];
       end;

    //  
    2: begin                                     {   }
         S:= 0;                                  {  }
         if tmp[0] then S:= 1;                   {   4 }
         if tmp[2] then S:= 2+S;
         if tmp[4] then S:= 3+S;
         if tmp[6] then S:= 4+S;
         if S > 8  then S:= 8;                   { }
         for n:= 0 to 7 do Bin[n]:= (n = S-1);   { }
       end;

    // 
    3: for n:= 0 to 7 do                         {  }
         Bin[n]:= (n <= Col) and (Col <> 0);     { }

    //   1
    4: begin                                     {   }
         for n:= 0 to 3 do
         begin
           Bin[n]:= (Col > 3-n) and (Col < 8-n); { }
           Bin[7-n]:= Bin[n];                    { }
         end;
       end;

    //   2
    5: begin                                     {  }
         S:= Col div 2;                          {  2   }
         if Col <> 0 then S:= S+1;               { 1;  Col=0   S=0}
         for n:= 0 to 3 do
         begin
           Bin[n]:= (S > 3-n);                   { }
           Bin[7-n]:= Bin[n];                    { }
         end;
       end;

    //    2
    6: begin                                     {  }
         S:= Col div 2;                          {  2   }
         if Col <> 0 then S:= S+1;               { 1;  Col=0   S=0}
         for n:= 0 to 3 do
         begin
           Bin[n]:= (S = 4-n);                   { }
           Bin[7-n]:= Bin[n];                    { }
         end;
       end;

  end;

  //     //

  //  
  if Form1.CheckBoxStrob.Checked then
     for n:= 0 to 7 do
     if Bin[n] = BufStrob[n] then Bin[n]:= false
                             else BufStrob[n]:= not BufStrob[n];


  // 
  //        USB 
  //   
  if Form1.CheckBoxSoft.Checked
    then                       {  }

     for n:= 0 to 7 do
      begin
       if Bin[n] then BufFlash[n]:= 255             {}
                 else if BufFlash[n] > FlashFall    {}
				                 then BufFlash[n]:= Round(BufFlash[n]-FlashFall)
						             else BufFlash[n]:= 0;      {}
		   Result[n]:= BufFlash[n];                     { }
      end
		
    else                       {  }
     for n:= 0 to 7 do
	     if Bin[n] then Result[n]:= 255               { }
                 else Result[n]:= 0;                {}

end;


 //==================    ==================//

procedure DrawSpectrum;
//    
//  ,     CPU
//     
type
  TPolyArray = array[0..MaxValue] of TPoint;

var
  n: Word;
  PolyBufLine, PolyBufPeak: TPolyArray;

begin
  //   
  for n:= 0 to MaxValue do
  begin
    PolyBufLine[n]:= Point(n,round(265-BufLine[n]));
    PolyBufPeak[n]:= Point(n,round(264-BufPeak[n]));
  end;

  PolyBufLine[0]:= Point(0,265);                {   }
  PolyBufLine[MaxValue]:= Point(MaxValue,265);  {  }

  //   BufFFT
  with BufFFT.Canvas do
  begin
    //    BufFFT
    Pen.Color:= clBlack;              {   }
    Brush.Color:= clBlack;            {   }
    Rectangle(0,0,512,265);           { }

    //      BufFFT
    Pen.Color:= clYellow;             {   }
    Brush.Color:= clYellow;           {   }
    Polygon(PolyBufLine);             {  }

    //      BufFFT
    Pen.Color:= clRed;                {   }
    Polyline(PolyBufPeak);            {  }
  end;

  //   BufFFT  ImageFFT
  Form1.ImageFFT.Picture.Bitmap.Assign(BufFFT);
end;


procedure DrawBand(Col: TBus);
//    
//  ,     CPU
//     

const
  FabColor: array[1..8] of TColor =   {   }
            (clRed,clLime,clOlive,
             clMedGray,clTeal,clAqua,
             clFuchsia,clBlue);
var
  a, b, n: Word;

begin
  //   BufFFT
  with BufFFT.Canvas do
  begin
    //    BufFFT
    Pen.Color:= clBlack;              {   }
    Brush.Color:= clBlack;            {   }
    Rectangle(0,0,512,265);           { }

    //      BufFFT
    if FilNamb > 0 then begin         {  ,    }
                          a:= FilNamb;
                          b:= FilNamb;
                        end
                   else begin         {   }
                          a:= 1;
                          b:= 8;
                        end;
      for n:= a to b do
      begin
        Pen.Color:= FabColor[n];                       {  }
        Brush.Color:= FabColor[n];                     {  }
        Rectangle(Rg.Fa[n],265-Col[n-1],Rg.Fb[n],265); { }
      end;

  end;

  //   BufFFT  ImageFFT
  Form1.ImageFFT.Picture.Bitmap.Assign(BufFFT);
end;


procedure DrawLight(Bus: TBus);
//    
const Y = 180;                        {  }
var
  n, RG, B: Byte;
  cLamp: TColor;

begin
  for n:= 0 to 7 do                   {  }
  begin
    //       
    RG:= Y + muldiv(255-Y, Bus[n], 255);
    B := muldiv(Y, 255-Bus[n], 255);
    cLamp:= RGB(RG, RG, B);

    //    YcLamp
    with Form1.ImageLamp.Canvas do
    begin
      Pen.Color  := cLamp;            { }
      Brush.Color:= cLamp;            { }
      Ellipse(6+36*n,4,30+36*n,28);   { }
      Draw(6+36*n,4,bLamp)            {  }
    end;
  end;
end;


 //================     =================//

procedure TForm1.Ic(n: Integer; Icon: TIcon);
//     
var Nim: TNotifyIconData;
begin
 with Nim do
  begin
   cbSize:= SizeOf(Nim);
   Wnd:= Form1.Handle;
   uID:= 1;
   uFlags:= NIF_ICON or NIF_MESSAGE or NIF_TIP;
   hIcon:= Icon.Handle;
   uCallbackMessage:= wm_user+1;
   szTip:= ModulName;
  end;
 case n of
  1: Shell_NotifyIcon(Nim_Add,@Nim);
  2: Shell_NotifyIcon(Nim_Delete,@Nim);
  3: Shell_NotifyIcon(Nim_Modify,@Nim);
 end;
end;


procedure TForm1.ControlWindow(var Msg: TMessage);
//    ''
begin
  if Msg.WParam = SC_MINIMIZE then
    begin
      Ic(1,Form1.Icon);                         {   }
      ShowWindow(Handle,SW_HIDE);               { }
      ShowWindow(Application.Handle,SW_HIDE);   {   TaskBar'}
    end
    else inherited;
end;


procedure TForm1.onMinimizeProc(Sender: TObject);
//    onMinimize
begin
  PostMessage(Handle,WM_SYSCOMMAND,SC_MINIMIZE,0);
end;


procedure TForm1.IconOnClick(var Msg: TMessage);
//       
begin
 //       
 if Msg.LParam = WM_LBUTTONDBLCLK then
   begin
     Ic(2,Application.Icon);                       {   }
     ShowWindow(Handle,SW_SHOWNORMAL);             { }
     ShowWindow(Application.Handle,SW_SHOWNORMAL); {   TaskBar'}
   end;
end;


 //=============     =============//

procedure TForm1.ComboBoxFilterChange(Sender: TObject);
//    
begin
  FilNamb:= ComboBoxFilter.ItemIndex;          {   1..8}
  if ComboBoxFilter.ItemIndex > 0 then         {  }
    begin
      ScrollBarFrom.Enabled:= true;            { ScrollBarFrom}
      ScrollBarTo.Enabled:= true;              { ScrollBarTo}
      ScrollBarFrom.Position:= Rg.Fa[FilNamb]; {   Rg.Fa}
      ScrollBarTo.Position:= Rg.Fb[FilNamb];   {   Rg.Fb}
    end
                  else                         {   }
    begin
      ScrollBarFrom.Enabled:= false;           { ScrollBarFrom}
      ScrollBarTo.Enabled:= false;             { ScrollBarTo}
      Label1.Caption:= '0';                    { }
      Label2.Caption:= '0';                    { }
    end;
end;


procedure TForm1.ScrollBarFromChange(Sender: TObject);
//       Rg.Fa
begin
  ScrollBarFrom.Min:= 0;                    {   From}
  ScrollBarFrom.Max:= MaxValue-FIntMin;     {   From}
  Rg.Fa[FilNamb]:= ScrollBarFrom.Position;
  Label1.Caption:= IntToStr(43*Rg.Fa[FilNamb]);    {    1 . = 43 }
  if Rg.Fb[FilNamb]-Rg.Fa[FilNamb] < FIntMin then  {From   To}
    begin
      Rg.Fb[FilNamb]:= Rg.Fa[FilNamb]+FIntMin;
      ScrollBarTo.Position:= Rg.Fb[FilNamb];       {  To}
      Label2.Caption:= IntToStr(43*Rg.Fb[FilNamb]);
    end;
end;


procedure TForm1.ScrollBarToChange(Sender: TObject);
//       Rg.Fb 
begin
  ScrollBarTo.Min  := FIntMin;                {   To}
  ScrollBarTo.Max  := MaxValue;               {   To}
  Rg.Fb[FilNamb]:= ScrollBarTo.Position;
  Label2.Caption:= IntToStr(43*Rg.Fb[FilNamb]);    {   }
  if Rg.Fb[FilNamb]-Rg.Fa[FilNamb] < FIntMin then  {To   From}
    begin
      Rg.Fa[FilNamb]:= Rg.Fb[FilNamb]-FIntMin;
      ScrollBarFrom.Position:= Rg.Fa[FilNamb];     {  From}
      Label1.Caption:= IntToStr(43*Rg.Fa[FilNamb]);
    end;
end;


 //===================   USB  ===================//

procedure TForm1.HidCtlArrival(HidDev: TJvHidDevice);
//    HID 
//  OnArrival  HidCtl
begin
//    ,   
  If not Assigned(WorkDev) then HidCtl.Enumerate;
end;


function TForm1.HidCtlEnumerate(HidDev: TJvHidDevice;
                                const Idx: Integer): Boolean;
//      
//  OnEnumerate  HidCtl
begin
  If (Trim(HidDev.ProductName) = ProductName) and
     (HidDev.Attributes.VendorID  = VendorID) and
     (HidDev.Attributes.ProductID = ProductID)
     then                                      {  , }
       begin
         HidCtl.CheckOutByIndex(WorkDev, Idx); {   }
         Caption:= TitleDeviceOn;              {  }
         Result:= false;                       { }
       end
     else Result:= true;                       {  }
end;


procedure TForm1.HidCtlRemoval(HidDev: TJvHidDevice);
//    HID 
//  OnRemoval  HidCtl
begin
  If HidDev = WorkDev then          {   , }
    begin                 
      WorkDev:= nil;                {  }
      Caption:= TitleDeviceOff;     { }
    end;
end;


function TForm1.WorkDevSetFeature(Bus: TBus): Boolean;
//    WorkDev
var
  Report: array [0..8] of Byte;     {   HID}
  n: Byte;
  
begin
  Report[0]:= 0;                    {ReportID -  !}
  for n:= 1 to 8 do
    Report[n]:= Bus[n-1];           { , Bus[0..7]}
  If Assigned(WorkDev)
    then Result:= WorkDev.SetFeature(Report, WorkDev.Caps.FeatureReportByteLength)
    else Result:= false;            { }
end;


 //=================  Winamp-  =================//

procedure ModuleInit;
//   
begin
  Application.CreateForm(TForm1,Form1);  { }
  Form1.Caption:= TitleDeviceOff;        {  }
  Form1.Show;                            {   }

  with Form1 do
  begin
    //   
    FillChar(BufLine, MaxValue+1, 0);   { }
    FillChar(BufPeak, MaxValue+1, 0);   { }
    FillChar(BufStrob, 8, false);       { }
    FillChar(BufFlash, 8, 0);           { }
    FillChar(Ref, 8, 0);                { }
    //   bLamp
    bLamp:= TBitMap.Create;
    bLamp.LoadFromResourceName(HInstance,'Lamp');   {   }
    bLamp.Transparent:= true;           {  }
    //   BufFFT
    BufFFT:= TBitMap.Create;
    BufFFT.Width:= ImageFFT.Width;      { }
    BufFFT.Height:= ImageFFT.Height;    { }
    BufFFT.Transparent:= true;          {  }
    //  ImageFFT
    with ImageFFT.Canvas do
    begin
      Pen.Color:= clBlack;              {   }
      Brush.Color:= clBlack;            {   }
      Rectangle(0,0,512,265);           { }
    end;
    //  ImageLamp
    with ImageLamp.Canvas do
    begin
      Pen.Color:= clBtnFace;            {   }
      Brush.Color:= clBtnFace;          {   }
      Rectangle(0,0,288,32);            { }
    end;
    //  
    Rg:= ReadRegData;                   {    - RegData.pas}
    ComboBoxMode.ItemIndex:= Rg.Prg;
    CheckBoxStrob.Checked := Rg.Str;
    CheckBoxSoft.Checked  := Rg.Soft;
    //  
    Render.Enabled:= true;
  end;
end;


procedure TForm1.TimerRender(Sender: TObject);
//    
{     
  latencyMs = 25  delayMS = 25   VisWinamp.
    Render.Interval = 30 }

//   
var
  Level, Value: TBus;

begin
  Render.Enabled:= false;           { }
  Level:= FFTFilter;                {   }
  Value:= Illumination(Level);      {    }
  WorkDevSetFeature(Value);         {  HID-}
  if IsWindowVisible(Form1.Handle)  {   , }
  then begin                        { ,    }
         if CheckBoxBorder.Checked  {   }
           then DrawBand(Level)     {   }
           else DrawSpectrum;       {  }
         DrawLight(Value);          {   }
       end;
  Render.Enabled:= true;            { }
end;


procedure ModuleQuit;
//    
var
  Bus: TBus;

begin
  with Form1 do
  begin
    //   
    Render.Enabled:= false;
    //  
    Rg.Prg:= ComboBoxMode.ItemIndex;  {  }
    Rg.Str:= CheckBoxStrob.Checked;   {  }
    Rg.Soft:= CheckBoxSoft.Checked;   {  }
    if CheckBoxSave.Checked then      {  , }
       WriteRegData(Rg);              {    - RegData.pas}
    //  USB 
    FillChar(Bus, 8, 0);              { }
    WorkDevSetFeature(Bus);           {  HID-}
    //  
    FreeAndNil(HidCtl);               {  TJvHidDeviceController}
    FreeAndNil(bLamp);                {  bLamp}
    FreeAndNil(BufFFT);               {  BufFFT}
    //  
    Close;
  end;
end;


 //============================== END =============================//

end.
