unit VisWinamp;

{
   :    Winamp-
   :    Winamp-
    :  
           pvabox@mail.ru
}


{ ------------------------------------------------------------------------- }
{        Main.pas:           }
{                                                                           }
{    Const MaxValue  = 512;                                                 }
{          ModulName = 'BCM Dynamic plugin';                                }
{    Type TFFTData = array[0..MaxValue] of Byte;                            }
{    Var  FFTData: TFFTData;                                                }
{                                                                           }
{    procedure ModuleInit;                                                  }
{    procedure ModuleQuit;                                                  }
{ ------------------------------------------------------------------------- }


interface


uses
  Windows, SysUtils, Main;

type
  PWinampVisModule =^TWinampVisModule;
  TWinampVisModule = record
    description:     PChar;
    hwndParent:      HWND;
    hDllInstance:    HINST;
    sRate:           Integer;
    nCh:             Integer;
    latencyMs:       Integer;
    delayMs:         Integer;
    spectrumNch:     Integer;
    waveformNch:     Integer;
    spectrumData:    array[0..1,0..575] of Byte;
    waveformData:    array[0..1,0..575] of Byte;
    Config:          procedure(this_mod: PWinampVisModule); cdecl;
    Init:            function (this_mod: PWinampVisModule): Integer; cdecl;
    Render:          function (this_mod: PWinampVisModule): Integer; cdecl;
    Quit:            procedure(this_mod: PWinampVisModule); cdecl;
    userData:        Pointer;
  end;

  PWinampVisHeader = ^TWinampVisHeader;
  TWinampVisHeader = record
    version:         Integer;
    description:     PChar;
    getModule:       function(i: Integer): PWinampVisModule; cdecl;
  end;
  WinampVisGetHeaderType = function: PWinampVisHeader;


const ver = 600;                    { }
      des = ModulName+' ver 6.00';  { }

function  winampVisGetHeader: PwinampVisHeader; cdecl; export;
function  getModule(which: Integer): PwinampVisModule; cdecl;
procedure config(this_mod: PwinampVisModule); cdecl;
function  init(this_mod: PwinampVisModule): Integer; cdecl;
function  render(this_mod: PwinampVisModule): Integer; cdecl;
procedure quit(this_mod: PwinampVisModule); cdecl;

implementation

const
//  
VisHeader: TWinampVisHeader =
           (version: ver; description: des; getModule: getModule);

//    
VisModule: TWinampVisModule =
           (description:     des;
            hwndParent:      0;
            hDllInstance:    0;
            sRate:           0;
            nCh:             0;
            latencyMs:       25;
            delayMS:         25;
            spectrumNch:     1;
            waveformNch:     0;
            Config:          config;
            Init:            init;
            Render:          render;
            Quit:            quit);

//   Winamp-  
function WinampVisGetHeader: PWinampVisHeader;
begin
  Result:= @VisHeader;
end;

//     Winamp-
function getModule(which: Integer): PWinampVisModule;
begin
  if which = 0 then Result:= @VisModule else Result:= nil;
end;

//   
//   Winamp  Configure
procedure Config(this_mod: PWinampVisModule);
begin
  MessageBox(0,
    '   - '#13#10+
    '    '#13#10+
    ' HID USB '#13#10#13#10+
    ':  '#13#10+
    'pvabox@mail.ru',
    ' ',
     MB_ICONINFORMATION);
end;

//   
//   Winamp  Start
function Init(this_mod: PWinampVisModule): Integer;
begin
  ModuleInit;                {   - Main.pas}
  Result:= 0;                {  }
end;

//    
function Render(this_mod: PWinampVisModule): Integer;
var
  n: Word;
  
begin
  for n:= 0 to MaxValue do   {   MaxValue }
    FFTData[n]:= this_mod.spectrumData[0,n];
  Result:= 0;                {  }
end;

//    
procedure Quit(this_mod: PWinampVisModule);
begin
  ModuleQuit;                {  - Main.pas}
end;

 //============================== END ==============================//


end.
