unit main;

{
:      JvHidControllerClass
 JvTimer,     JEDI,   :
http://sourceforge.net/projects/jvcl/files/
}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, ComCtrls,
  StdCtrls, Buttons, JvHidControllerClass, JvComponentBase;
  
type
  TBus   = array[1..8] of Byte;

  TForm1 = class(TForm)
    GroupBoxStatus: TGroupBox;
    GroupBoxLED: TGroupBox;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    TrackBar8: TTrackBar;
    Label1   : TLabel;
    Label2   : TLabel;
    Label3   : TLabel;
    Label4   : TLabel;
    Label5   : TLabel;
    Label6   : TLabel;
    Label7   : TLabel;
    Label8   : TLabel;
    Label9   : TLabel;
    Label10  : TLabel;
    Label11  : TLabel;
    Label12  : TLabel;
    Label13  : TLabel;
    Label14  : TLabel;
    Label15  : TLabel;
    Label16  : TLabel;
    Label17  : TLabel;
    Label18  : TLabel;
    Label19  : TLabel;
    Label20  : TLabel;
    Label21  : TLabel;
    Label22  : TLabel;
    Label23  : TLabel;
    Label24  : TLabel;
    Label25  : TLabel;
    Label26  : TLabel;
    Label27  : TLabel;
    HidCtl   : TJvHidDeviceController;
	
    procedure FormCreate(Sender: TObject);
    procedure TrackBarClick(Sender: TObject);
    procedure FormDistroy(Sender: TObject);
    procedure HidCtlArrival(HidDev: TJvHidDevice);
    function  HidCtlEnumerate(HidDev: TJvHidDevice;
              const Idx: Integer): Boolean;
    procedure HidCtlRemoval(HidDev: TJvHidDevice);
    function  WorkDevSetFeature(Bus: TBus): Boolean;


  private
    { Private declarations }
  public
    { Public declarations }
    WorkDev   : TJvHidDevice;
  end;

const
  //   
  Lim = 255;       { 16   15..255}

  //  
  ProductName    = 'BCM Dynamic USB Device';
  VendorID       =  $16c0;
  ProductID      =  $05df;

var
  Form1     : TForm1;

implementation

{$R *.dfm}

//------------------------    -------------------------//

procedure TForm1.FormCreate(Sender: TObject);
//   
//  onCreate  Form1
begin
  //   
  TrackBar1.Max:= Lim;
  TrackBar2.Max:= Lim;
  TrackBar3.Max:= Lim;
  TrackBar4.Max:= Lim;
  TrackBar5.Max:= Lim;
  TrackBar6.Max:= Lim;
  TrackBar7.Max:= Lim;
  TrackBar8.Max:= Lim;

  //    
  Label14.Caption:= ProductName;
  Label15.Caption:= Format('%x',[VendorID]);  {  }
  Label16.Caption:= Format('%x',[ProductID]); {  }

end;

procedure TForm1.TrackBarClick(Sender: TObject);
//   TrackBar    
var
  Bus: TBus;

begin
  //   TrackBar
  Bus[1]:= Lim-TrackBar1.Position;
  Bus[2]:= Lim-TrackBar2.Position;
  Bus[3]:= Lim-TrackBar3.Position;
  Bus[4]:= Lim-TrackBar4.Position;
  Bus[5]:= Lim-TrackBar5.Position;
  Bus[6]:= Lim-TrackBar6.Position;
  Bus[7]:= Lim-TrackBar7.Position;
  Bus[8]:= Lim-TrackBar8.Position;

  //   TrackBar
  label20.Caption:= IntToStr(Bus[1]);
  label21.Caption:= IntToStr(Bus[2]);
  label22.Caption:= IntToStr(Bus[3]);
  label23.Caption:= IntToStr(Bus[4]);
  label24.Caption:= IntToStr(Bus[5]);
  label25.Caption:= IntToStr(Bus[6]);
  label26.Caption:= IntToStr(Bus[7]);
  label27.Caption:= IntToStr(Bus[8]);

  //    WorkDev
  If WorkDevSetFeature(Bus)              {  }
    then Label18.Caption:= ' ok! '
    else Label18.Caption:= ' error '
    
end;


procedure TForm1.FormDistroy(Sender: TObject);
//    +
//  onDistroy  Form1
var
  Bus: TBus;

begin
  FillChar(Bus, Length(Bus), 0);   { }
  WorkDevSetFeature(Bus);   {    }
  FreeAndNil(HidCtl);       {   TJvHidDeviceController}
end;

//-------------------------   USB  -------------------------//

procedure TForm1.HidCtlArrival(HidDev: TJvHidDevice);
//    
//  OnArrival  HidCtl
begin
//    ,   
  If not Assigned(WorkDev) then HidCtl.Enumerate;
end;


function TForm1.HidCtlEnumerate(HidDev: TJvHidDevice;
                                const Idx: Integer): Boolean;
//      
//  OnEnumerate  HidCtl
begin
  If (Trim(HidDev.ProductName) = ProductName) and
     (HidDev.Attributes.VendorID  = VendorID) and
     (HidDev.Attributes.ProductID = ProductID)
     then                                      {  , }
       begin
         HidCtl.CheckOutByIndex(WorkDev, Idx); {   }
         Label17.Caption:= 'connected';
         Result:= false;                       { }
       end
     else Result:= true;                       {  }
end;


procedure TForm1.HidCtlRemoval(HidDev: TJvHidDevice);
//    HID 
//  OnRemoval  HidCtl
begin
  If HidDev = WorkDev then             {   , }
    begin
      WorkDev:= nil;                   {  }
      Label17.Caption:= 'disconnected' { }
    end;
end;


function TForm1.WorkDevSetFeature(Bus: TBus): Boolean;
//    WorkDev
var
  Report: array [0..8] of Byte;        {   HID}
  n: Byte;
  
begin
  Report[0]:= 0;                       {ReportID -  !}
  for n:= 1 to 8 do
    Report[n]:= Bus[n];                { }
  If Assigned(WorkDev)
    then Result:= WorkDev.SetFeature(Report, WorkDev.Caps.FeatureReportByteLength)
    else Result:= false;               { }
end;

//----------------------------------  -----------------------------------//


end.